SET DEPLOY_FOLDER=\\ISA209\OfficeWeb
SET SOURCE_FOLDER=.\deploy
SET VERSION_INFO=Log\VersionInfo.txt
SET COAUTHORING_SERVER_URL=http://192.168.3.213:3000

SET API_FUNC_FILE_NAME=api_functions
SET SOURCE_DOC_API_FUNC_FOLDER=Log
SET SOURCE_TAB_API_FUNC_FOLDER=..\..\OfficeWebExcel\.build\Log
SET DEPLOY_API_FUNC_FOLDER=\\TESTPC-2\OnlineDocuments\API
SET DEPLOY_DOC_API_FUNC_FOLDER=%DEPLOY_API_FUNC_FOLDER%
SET DEPLOY_TAB_API_FUNC_FOLDER=%DEPLOY_API_FUNC_FOLDER%\Spreadsheet

SET /P DEPLOY_VER= < %VERSION_INFO%
SET /a DEPLOY_VER=%DEPLOY_VER%+1
ECHO %DEPLOY_VER% > %VERSION_INFO%

SET /a MAJOR_DEPLOY_VER=%DEPLOY_VER%/1000
SET /a MINOR_DEPLOY_VER=%DEPLOY_VER%%%1000

SET DEPLOY_SUB_FOLDER=%DEPLOY_FOLDER%\v%MAJOR_DEPLOY_VER%.%MINOR_DEPLOY_VER%
SET OUTPUT_API_FUNC_FILE_NAME=%API_FUNC_FILE_NAME%_v%MAJOR_DEPLOY_VER%.%MINOR_DEPLOY_VER%.js

MKDIR "%DEPLOY_SUB_FOLDER%" || exit /b 1

XCOPY /S "%SOURCE_FOLDER%\3rdparty" "%DEPLOY_SUB_FOLDER%\3rdparty\" /Y || exit /b 1 
XCOPY /S "%SOURCE_FOLDER%\apps" "%DEPLOY_SUB_FOLDER%\apps\" /Y || exit /b 1
XCOPY /S "%SOURCE_FOLDER%\sdk" "%DEPLOY_SUB_FOLDER%\sdk\" /Y || exit /b 1

ECHO var g_cAscCoAuthoringUrl = "%COAUTHORING_SERVER_URL%"; > "%DEPLOY_SUB_FOLDER%\sdk\OfficeWebCommon\docscoapisettings.js"

XCOPY /S "%SOURCE_DOC_API_FUNC_FOLDER%\%API_FUNC_FILE_NAME%.js" "%DEPLOY_DOC_API_FUNC_FOLDER%\%OUTPUT_API_FUNC_FILE_NAME%" /Y
XCOPY /S "%SOURCE_TAB_API_FUNC_FOLDER%\%API_FUNC_FILE_NAME%.js" "%DEPLOY_TAB_API_FUNC_FOLDER%\%OUTPUT_API_FUNC_FILE_NAME%" /Y

@ECHO Script finished successfuly. 
pause

